.TH metrics 1

.\" PF -- FrameMaker paragraph
.\" USE: .PF adjust left-indent first-indent right-indent
.de PF
.ad \\$1
.in \\$3
.ti \\$2
.\" @#what to do with right indents?
..
.\" Body
.PF b 0i 0i 0i
\fR\&\s10\&

.\" HeadRef
.PF b 0i 0i 0i
\fB\&\s18\&XcRichText

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&XcRichText - formatted text display widget

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&SYNOPSIS

.\" Code
.PF l 0.333i 0.333i 0i
.ta 0.167i 0.417i 0.667i 0.917i 1.167i 1.417i 1.667i 1.917i 2.167i 2.417i 2.667i
\fR\&\s9\&\fR\&\s9\&#include <Xc/RichText.h>

.\" Code
.PF l 0.333i 0.333i 0i
.ta 0.167i 0.417i 0.667i 0.917i 1.167i 1.417i 1.667i 1.917i 2.167i 2.417i 2.667i
\fR\&\s9\&

.\" Code
.PF l 0.333i 0.333i 0i
.ta 0.167i 0.417i 0.667i 0.917i 1.167i 1.417i 1.667i 1.917i 2.167i 2.417i 2.667i
\fR\&\s9\&widget = XtCreateManagedWidget(name, xcRichTextWidgetClass);

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&CLASS HIERARCHY

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Core -> XmPrimitive -> XcRichText

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&DESCRIPTION

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&XcRichText formats and displays a passage of text. In the default mode, this widget acts 
much like a limited XmText widget: it displays the contents of its value resource as text in 
the requested font, wrapping the text to fit the size of the window, and allows text selection 
with the mouse. Editing is not supported.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&But when the boolean resource rtf is true, the value resource is interpreted in Rich Text 
Format rather than plain ASCII. RTF is a document interchange format popularized by 
Microsoft Word. The XcRichText widget uses RTF character and paragraph formatting 
control words to choose fonts and lay out the text.

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&RESOURCES

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&In addition to the resources defined by superclasses, this widget defines the following:

.nf
Name                    Class           Type            Default ACCESS
----------------------- --------------- --------------- ------- ------
XmNbottomPosition       XmCTextPosition TextPosition    0       CSG
XmNmotionVerifyCallback XmCCallback     Callback        NULL    C
XcNfontPatterns         XcCFontPatterns XmStringTable   "*-fixed-*,
        *-adobe-times-*,*-adobe-helvetica-*,*-adobe-courier-*,
        *-script-*,*-decor-*,*-adobe-symbol-*"                  CSG
XmNmarginHeight         XmCMarginHeight Dimension       10      CSG
XmNmarginWidth          XmCMarginWidth  Dimension       10      CSG
XcNrtf                  XcCRtf          Boolean         0       CSG
XmNtopPosition          XmCTextPosition TextPosition    0       CSG
XmNvalue                XmCValue        String          NULL    CSG
.fi

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNtopPosition

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNbottomPosition

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&These default to the beginning and the end of the text. If they are set to some subrange of 
the text, only that range of text is included in the display.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&For example, they could be set to the first and last text positions on page 7, and only page 7 
would be displayed.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNfontPatterns\p
Specifies the translation from RTF font families to X fonts.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Fonts in an RTF document are divided into six font families: nil, roman, swiss, modern, 
script, decor, and tech.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&To select an X font for a run of text, the widget calls XListFonts using the pattern corre\c
sponding to the font family of the run of text. Of the resulting fonts, the widget chooses the 
font whose weight, slant and size match the RTF character format.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Note that the size of a font is computed from its height in pixels, using the resolution of the 
server. The point size from the font name is ignored, as it does not necessarily apply on all 
servers.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNmotionVerifyCallback\p
Specifies the list of callbacks that is called when the user clicks on the text or selects 
some text. The \fI\&\s10\&point\fR\&\s10\& and \fI\&\s10\&mark\fR\&\s10\& fields of the XcRichTextCallbackStruct indicate the char\c
acter offset where the user clicked and/or dragged. This allows applications to respond to 
mouse clicks on "hot" areas of text.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNmarginHeight\p
Specifies distance between the top(bottom) of the window and the first(last) line of text.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNmarginWidth\p
Specifies the distance between the left(right) side of the window and the text.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XcNrtf\p
Specifies whether the text is interpreted in RTF or plain text.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&XmNvalue\p
Specifies the text to display.

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&CALLBACKS

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&A pointer to the following structure is passed to each callback:

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&typedef struct{

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\& int \fI\&\s9\&reason\fR\&\s9\&;

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\& XEvent *\fI\&\s9\&event\fR\&\s9\&;

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&\ long \fI\&\s9\&mark\fR\&\s9\&, \fI\&\s9\&point\fR\&\s9\&;

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&\ char* \fI\&\s9\&value\fR\&\s9\&;

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&}XcRichTextCallbackStruct;

.\" BodyRef
.PF b 0.333i 0.333i 0i
.ta 0.792i
\fR\&\s10\&\fI\&\s10\&reason\fR\&\s10\& Indicates why the callback was invoked.

.\" BodyRef
.PF b 0.333i 0.333i 0i
.ta 0.792i
\fR\&\s10\&\fI\&\s10\&event\fR\&\s10\&  Points to the \fB\&\s10\&XEvent\fR\&\s10\& that triggered the callback.

.\" BodyRef
.PF b 0.333i 0.333i 0i
.ta 0.792i
\fR\&\s10\&\fI\&\s10\&mark\fR\&\s10\&   Contains the position of the start of the selection.

.\" BodyRef
.PF b 0.333i 0.333i 0i
.ta 0.792i
\fR\&\s10\&\fI\&\s10\&point\fR\&\s10\&  Contains the position of the end of the selection. If \fI\&\s10\&mark\fR\&\s10\& is equal to \fI\&\s10\&point\fR\&\s10\&, the 
selection is empty and \fI\&\s10\&mark\fR\&\s10\& and \fI\&\s10\&point\fR\&\s10\& are the position where the mouse click 
occurred.

.\" BodyRef
.PF b 0.333i 0.333i 0i
.ta 0.792i
\fR\&\s10\&\fI\&\s10\&value\fR\&\s10\&  Points to the widgetUs value string resource

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&PUBLIC FUNCTIONS

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&Widget XcCreateRichText( Widget p, String name, ArgList args, 
Cardinal n);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Same as \fR\&\s10\&XtCreateWidget(name, xcRichTextWidgetClass, p, args, n).

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&char *XcRichTextGetString (Widget widget);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Returns a newly allocated copy of the value resource.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&long XcRichTextGetLastPosition (Widget widget);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Returns the number of bytes in the value resource.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&char *XcRichTextGetSelection (Widget widget, int strip_rtf);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Returns a newly allocated copy of the selected text in the widget. Returns 0 if there is no 
text selected. If \fR\&\s10\&strip_rtf\fR\&\s10\& is true, RTF formatting codes are removed from the selected 
text.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&void XcRichTextSetSelection (Widget widget, XmTextPosition first, 
XmTextPosition last, Time set_time);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Selects the text between \fR\&\s10\&first\fR\&\s10\& and \fR\&\s10\&last\fR\&\s10\& and makes that text available as the PRIMARY 
selection as of \fR\&\s10\&set_time\fR\&\s10\&.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&void XcRichTextClearSelection (Widget widget, Time clear_time);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Unhighlights any selected text and disowns all selections.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&Boolean XcRichTextGetSelectionPosition (Widget widget, XmTextPosition 
*left, XmTextPosition *right);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Returns true only if there is a range of text selected. The range is stored in \fR\&\s10\&*left\fR\&\s10\& and 
\fR\&\s10\&*right\fR\&\s10\&.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&long XcRichTextXYToPos (Widget widget, Position x, Position y);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Returns the position of the character at the position (x, y) within the widget.

.\" CodeRef
.PF l 0.666i 0.666i 0i
.ta -0.166i 0.084i 0.334i 0.584i 0.834i 1.084i 1.334i 1.584i 1.834i 2.084i 2.334i
\fR\&\s9\&Boolean XcRichTextPosToXY (Widget widget, long pos, Position *x, 
Position *y);

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Locates a character in the window. If the character position is valid, returns true and stores 
the x and y coordinates of the character in \fR\&\s10\&*x\fR\&\s10\& and \fR\&\s10\&*y\fR\&\s10\&.

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&TRANSLATIONS

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&<Btn1Down>: select-start() \p
<Btn1Motion>: extend-adjust() \p
<Btn1Up>: extend-end(PRIMARY, CUT_BUFFER0) MotionVerify()\p
<Btn3Down>: extend-start() \p
<Btn3Motion>: extend-adjust() \p
<Btn3Up>: extend-end(PRIMARY, CUT_BUFFER0) 

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&ACTION ROUTINES

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\& select-start():\p
Any existing text selection is unhighlighted, and a new text selection begins at the loca\c
tion of the mouse event.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&extend-start():\p
The existing text selection is extended to the location of the mouse event.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&extend-adjust():\p
The selection is updated to include the region from where \fB\&\s12\&select-start \fR\&\s10\&occurred to the 
location of the mouse event.

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&extend-end(\fI\&\s10\&atom\fR\&\s10\&):\p
The RichText widget asserts ownership of the selection indicated by \fI\&\s10\&atom\fR\&\s10\& (usually 
\fB\&\s12\&PRIMARY\fR\&\s10\&).

.\" IndentItemRef
.PF b 0.25i 0.5i 0i
\fR\&\s10\&MotionVerify():\p
The location of the mouse event is translated to a position within the text and passed to 
\fB\&\s12\&MotionVerifyCallback\fR\&\s10\&.

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&LIMITATIONS

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&The XcRichText implements a subset of the RTF standard from Microsoft. Basic character 
and paragraph formatting options are implemented, but section and document formatting 
are not. Most unimplemented codes are simply ignored. Severe errors in the RTF string will 
cause a blank display.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Paragraph formatting includes left, right, and first indents and space after. Borders, side-by-
side paragraphs, and absolutely positioned objects are not supported.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Character formatting includes underlining, color, and font family, size, wieght, and slant.

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&Standard Macintosh image formats are not supported. The hex data in RTF picture groups 
are interpreted as SunRaster 1-bit images, with RLE compression.

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&RELATED INFORMATION

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&\fR\&\s10\&Core(3X), XmPrimitive(3X), XmText(3X)

.\" BodyRef
.PF b 0.333i 0.333i 0i
.nf
\fR\&\s10\&Microsoft
Rich Text Format Specification
Microsoft Corporation
Department: RTF
16011 NE 36th Way
Box 97017
Redmond, WA 98073-9717

.\" HeadRef1
.PF l 0i 0i 0i
\fR\&\s11\&AUTHOR

.\" BodyRef
.PF b 0.333i 0.333i 0i
.nf
\fR\&\s10\&Daniel W. Connlly
Software Development Engineer
CONVEX Computer Corp.
connolly@convex.com

.\" BodyRef
.PF b 0.333i 0.333i 0i
\fR\&\s10\&

