/* image.h -- definitions for image building code
 * $Id: image.h,v 1.3 92/08/20 16:47:40 connolly Exp $
 * Copyright 1992 by Convex Computer Corporation, Richardson, Texas.
 * See the COPYRIGHT file for details.
 */

#include <X11/Xlib.h>

Pixmap
createPixmapFromHexData(Display* disp,
			Drawable dest,
			const char* data);
/* USE: data = "0123456789ABCDEF\nFF00FF00FF00FF00...";
 *      disp = XtDisplay(widget)
 *      dest = XtWindow(widget);
 *      pixmap = createPixmapFromHexData(disp, dest, data);
 *      XCopyArea(disp, pixmap, dest, some_gc, 0, 0, w, h, dest_x, dest_y)
 */
